diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
index 8b969fc60..4fbc6bc9b 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
@@ -66,7 +66,7 @@ public class ItemPaintBrush extends Item {
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         blockPos = blockPos.add(direction, new TilePos());
-        if (!onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5)) {
+        if (!onUseOnBlock(selfStack, world, null, blockPos, direction.side(), 0.5, 0.5)) {
             AABBdc box = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1, blockPos.y() + 1, blockPos.z() + 1);
             List<MobSheep> entities = world.getEntitiesWithinAABB(MobSheep.class, box);
             if (!entities.isEmpty()) {
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
index 663c88b78..1cecb614d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -53,12 +53,12 @@ public class ItemPebble extends Item implements IDispensable {
             return false;
         }
 
+        final var pebble = Blocks.OVERLAY_PEBBLES.getLogic();
+
         // Check if we're placing "inside" a layer
         if (block == Blocks.OVERLAY_PEBBLES && side == Side.TOP) {
             final int newMeta = meta + 1;
-            if (!world.canPlaceOnSurfaceOfBlock(blockPos.down(new TilePos()))) {
-                return false;
-            }
+            if (!pebble.isSupported(world, blockPos, Side.BOTTOM)) return false;
 
             if (newMeta < BlockLogicOverlayPebbles.MAX_PEBBLES) {
                 world.setBlockTypeDataNotify(blockPos, Blocks.OVERLAY_PEBBLES, newMeta);
@@ -70,7 +70,7 @@ public class ItemPebble extends Item implements IDispensable {
 
         // Offset position
         if (block != Blocks.AIR) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            blockPos = blockPos.add(side.direction(), new TilePos());
             block = world.getBlockType(blockPos);
             meta = world.getBlockData(blockPos);
         }
@@ -80,7 +80,7 @@ public class ItemPebble extends Item implements IDispensable {
             final int newMeta = meta + 1;
 
             final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
-            if (!world.checkIfAABBIsClear(bbBox) || !world.canPlaceOnSurfaceOfBlock(blockPos.down(new TilePos()))) {
+            if (!world.checkIfAABBIsClear(bbBox) || !pebble.isSupported(world, blockPos, Side.BOTTOM)) {
                 return false;
             }
 
@@ -94,7 +94,7 @@ public class ItemPebble extends Item implements IDispensable {
         }
 
         // Regular placement, as all else fails
-        if (world.canBlockIdBePlacedAt(Blocks.OVERLAY_PEBBLES.id(), blockPos, false, side) && world.canPlaceOnSurfaceOfBlock(blockPos.down(new TilePos()))) {
+        if (world.canBlockIdBePlacedAt(Blocks.OVERLAY_PEBBLES.id(), blockPos, false, side) && !pebble.isSupported(world, blockPos, Side.BOTTOM)) {
             if (world.setBlockTypeNotify(blockPos, Blocks.OVERLAY_PEBBLES)) {
                 Blocks.OVERLAY_PEBBLES.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
                 world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
@@ -108,7 +108,7 @@ public class ItemPebble extends Item implements IDispensable {
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         ProjectilePebble projectilePebble = new ProjectilePebble(world, blockPos.x() + offX, blockPos.y() + offY, blockPos.z() + offZ);
-        projectilePebble.setHeading(direction.getOffsetX() * 0.6, direction.getOffsetY() == 0 ? 0.1 : direction.getOffsetY() * 0.6, direction.getOffsetZ() * 0.6f, 1.1F, 6F);
+        projectilePebble.setHeading(direction.offsetX() * 0.6, direction.offsetY() == 0 ? 0.1 : direction.offsetY() * 0.6, direction.offsetZ() * 0.6f, 1.1F, 6F);
         world.entityJoinedWorld(projectilePebble);
         selfStack.stackSize -= 1;
     }
@@ -117,7 +117,7 @@ public class ItemPebble extends Item implements IDispensable {
     public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
         if (selfStack.consumeItem(null)) {
             ProjectilePebble projectilePebble = new ProjectilePebble(world, x, y, z);
-            projectilePebble.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+            projectilePebble.setHeading(direction.offsetX(), direction.offsetY() + 0.1D, direction.offsetZ(), 1.1F, 6F);
             world.entityJoinedWorld(projectilePebble);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
index bbe148998..652c21498 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
@@ -32,33 +32,48 @@ public class ItemPlaceable extends Item {
             return false;
         }
         if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            blockPos = blockPos.add(side.direction(), new TilePos());
         }
         if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks()) {
             return false;
         }
-        if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
-            if (world.setBlockType(blockPos, this.blockToPlace)) {
-                if (player == null) {
-                    this.blockToPlace.onPlacedOnSide(world, blockPos, side, xHit, yHit);
-                } else {
-                    this.blockToPlace.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-                }
-                if (this.blockToPlace.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
-                    TileEntity tileEntity = world.getTileEntity(blockPos);
-                    if (tileEntity != null) {
-                        tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
-                    }
-                }
-                // notify self change after onPlacedByMob
-                // this should fix almost all bugs related to piston intercepting placement logic,
-                // with out change to individual onPlaced<_> logics.
-                world.notifyBlockChange(blockPos, this.blockToPlace);
-                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
-                return true;
+        if (!world.canBlockIdBePlacedAt(this.blockToPlace.id(), blockPos, false, side)) return false;
+
+        final var data = this.blockToPlace.getPlacedData(player, selfStack, world, blockPos, side, xHit, yHit);
+
+        final var pbloc = world.getBlockType(blockPos);
+        final int pdata = world.getBlockData(blockPos);
+
+        if (!world.setBlockTypeDataRaw(blockPos, this.blockToPlace, data)) return false;
+
+        if (pbloc != this.blockToPlace || pdata != data) {
+            pbloc.onRemoved(world, blockPos, pdata);
+        }
+
+        selfStack.consumeItem(player);
+
+        if (player == null) {
+            this.blockToPlace.onPlacedOnSide(world, blockPos, side, xHit, yHit);
+        } else {
+            this.blockToPlace.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
+        }
+
+        // TODO before or after tileentity?
+        this.blockToPlace.onPlacedByWorld(world, blockPos);
+
+        if (this.blockToPlace.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
+            TileEntity tileEntity = world.getTileEntity(blockPos);
+            if (tileEntity != null) {
+                tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
             }
         }
-        return false;
+
+        // notify self change after onPlacedByMob
+        // this should fix almost all bugs related to piston intercepting placement logic,
+        // with out change to individual onPlaced<_> logics.
+        world.notifyBlockChange(blockPos, this.blockToPlace);
+        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
+        return true;
     }
 
     @Override
@@ -66,7 +81,7 @@ public class ItemPlaceable extends Item {
         blockPos = blockPos.add(direction, new TilePos());
         Block<?> b = world.getBlockType(blockPos);
         if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-            onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5);
+            onUseOnBlock(selfStack, world, null, blockPos, direction.side(), 0.5, 0.5);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java b/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
index be24c7702..0c863de97 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemQuiver.java
@@ -124,7 +124,7 @@ public class ItemQuiver extends Item implements IArmorItem<HumanArmorShape>, IDi
         int count = getArrowCount(selfStack);
         if (count > 0) {
             final @NotNull ProjectileArrow arrow = new ProjectileArrow(world, x, y, z, 0);
-            arrow.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+            arrow.setHeading(direction.offsetX(), direction.offsetY() + 0.1D, direction.offsetZ(), 1.1F, 6F);
             arrow.setDoesArrowBelongToPlayer(true);
             world.entityJoinedWorld(arrow);
             setArrowCount(selfStack, count - 1);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java b/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
index e1e5fa509..a7a3d2668 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
@@ -40,7 +40,7 @@ public class ItemQuiverEndless extends Item implements IArmorItem<HumanArmorShap
     @Override
     public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
         final @NotNull ProjectileArrowPurple arrow = new ProjectileArrowPurple(world, x, y, z);
-        arrow.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+        arrow.setHeading(direction.offsetX(), direction.offsetY() + 0.1D, direction.offsetZ(), 1.1F, 6F);
         arrow.setDoesArrowBelongToPlayer(true);
         world.entityJoinedWorld(arrow);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
index 53bf94e5f..fc0c9432c 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
@@ -42,7 +42,7 @@ public class ItemRope extends ItemPlaceable {
             bp.set(tempPos);
         }
         if (!world.canPlaceInsideBlock(bp)) {
-            bp = bp.add(side.getDirection(), new TilePos());
+            bp = bp.add(side.direction(), new TilePos());
         }
         if (bp.y < 0 || bp.y >= world.getHeightBlocks()) {
             return false;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
index 37e8518f8..2340932c8 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSeeds.java
@@ -29,7 +29,7 @@ public class ItemSeeds extends Item {
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            blockPos = blockPos.add(side.direction(), new TilePos());
         }
         if (world.getBlockType(blockPos.down(new TilePos())) == Blocks.FARMLAND_DIRT && world.canPlaceInsideBlock(blockPos)) {
             if (world.setBlockTypeNotify(blockPos, this.cropsBlock)) {
@@ -47,7 +47,7 @@ public class ItemSeeds extends Item {
         Block<?> b = world.getBlockType(blockPos);
         boolean isFarmland = Block.hasLogicClass(b, BlockLogicFarmland.class);
         if (b == null || isFarmland || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-            onUseOnBlock(selfStack, world, null, blockPos.add(0, isFarmland ? 1 : 0, 0, new TilePos()), direction.getSide(), 0.5, 0.5);
+            onUseOnBlock(selfStack, world, null, blockPos.add(0, isFarmland ? 1 : 0, 0, new TilePos()), direction.side(), 0.5, 0.5);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
index 66a35f6c4..4b6c2a2eb 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSign.java
@@ -27,7 +27,7 @@ public class ItemSign extends Item {
         }
 
         if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            blockPos = blockPos.add(side.direction(), new TilePos());
         }
 
         if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks() || !Blocks.SIGN_POST_PLANKS_OAK.canPlaceAt(world, blockPos)) {
@@ -40,7 +40,7 @@ public class ItemSign extends Item {
             world.setBlockTypeData(blockPos, blockPlaced, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
         } else {
             blockPlaced = Blocks.SIGN_WALL_PLANKS_OAK;
-            world.setBlockTypeData(blockPos, blockPlaced, side.getId());
+            world.setBlockTypeData(blockPos, blockPlaced, side.id);
         }
         selfStack.consumeItem(player);
         world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, blockPlaced, EnumBlockSoundEffectType.PLACE);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
index f73ba4d5a..d92c19ad6 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSignPainted.java
@@ -26,7 +26,7 @@ public class ItemSignPainted extends ItemSign {
         }
 
         if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            blockPos = blockPos.add(side.direction(), new TilePos());
         }
 
         if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks() || !Blocks.SIGN_POST_PLANKS_OAK_PAINTED.canPlaceAt(world, blockPos)) {
@@ -40,7 +40,7 @@ public class ItemSignPainted extends ItemSign {
             world.setBlockTypeData(blockPos, blockPlaced, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | direction);
         } else {
             blockPlaced = Blocks.SIGN_WALL_PLANKS_OAK_PAINTED;
-            world.setBlockTypeData(blockPos, blockPlaced, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | side.getId());
+            world.setBlockTypeData(blockPos, blockPlaced, Blocks.SIGN_POST_PLANKS_OAK_PAINTED.getLogic().toMetadata(DyeColor.colorFromItemMeta(selfStack.getMetadata())) | side.id);
         }
         selfStack.consumeItem(player);
         world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, blockPlaced, EnumBlockSoundEffectType.PLACE);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSlimeball.java b/game/core/src/main/java/net/minecraft/core/item/ItemSlimeball.java
new file mode 100644
index 000000000..e95545d96
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSlimeball.java
@@ -0,0 +1,100 @@
+package net.minecraft.core.item;
+
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.piston.PistonCommon;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import static net.minecraft.core.block.piston.PistonCommon.IS_DETACHED;
+
+import java.util.Random;
+
+public class ItemSlimeball extends Item {
+
+    public ItemSlimeball(@NotNull String name, @NotNull String namespaceId, int id) {
+        super(name, namespaceId, id);
+        this.maxStackSize = 16;
+    }
+
+    private static boolean useOnBlock(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, @NotNull Direction direction
+    ) {
+        if (selfStack.stackSize <= 0) return false;
+        final var block = world.getBlockType(blockPos);
+        final boolean isBase = block == Blocks.PISTON_BASE;
+        final boolean isHead = !isBase && block == Blocks.PISTON_HEAD;
+        if (!isBase && !isHead) return false;
+        assert isBase || isHead;
+
+        int data = world.getBlockData(blockPos);
+        if (PistonCommon.TYPE.get(data) != PistonCommon.TYPE_NORMAL) return false;
+
+        // base can only be slimed while not extended and on the correct side
+        if (isBase) {
+            if (PistonCommon.IS_EXTENDED.bool(data)) return false;
+            final var faceDir = Direction.fromId(PistonCommon.DIRECTION.get(data));
+            if (faceDir != direction) return false;
+        }
+        
+        data = PistonCommon.TYPE.set(data, PistonCommon.TYPE_STICKY);
+        assert selfStack.consumeItem(player);
+
+        final var baseBlock = PistonCommon.BASE_BLOCK_MAP[PistonCommon.TYPE_STICKY];
+        final var headBlock = PistonCommon.HEAD_BLOCK_MAP[PistonCommon.TYPE_STICKY];
+
+        final var newBlock = (isBase) ? baseBlock : headBlock;
+
+        if (isBase || IS_DETACHED.bool(data)) {
+            world.setBlockTypeDataNotify(blockPos, newBlock, data);
+            return true;
+        }
+
+        // head need to update base type as well
+
+        final TilePos bpos = new TilePos();
+        int bdat = PistonCommon.headGetBase(data, bpos, world, blockPos);
+        
+        System.err.println(bpos);
+        System.err.println(Integer.toBinaryString(bdat));
+
+        final boolean isExtendedButNotDetached  = 
+            PistonCommon.IS_DETACHED_OR_EXTENDED.get(bdat) == PistonCommon.IS_EXTENDED.mask;
+        if (!isExtendedButNotDetached) {
+            world.setBlockTypeDataNotify(blockPos, newBlock, data);
+            return true;
+        }
+        
+        world.setBlockTypeDataRaw(bpos, baseBlock, bdat);
+        world.setBlockTypeDataRaw(blockPos, newBlock, data);
+        world.markBlockNeedsUpdate(bpos);
+        world.markBlockNeedsUpdate(blockPos);
+        world.notifyBlocksInCapsuleOfNeighborChange(direction.opposite(), blockPos, newBlock);
+
+        return true;
+    }
+
+    @Override
+    public boolean onUseOnBlock(
+        @NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player,
+        @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit
+    ) {
+        return useOnBlock(selfStack, world, player, blockPos, side.direction());
+    }
+
+    @Override
+    public void onUseByActivator(
+        @NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, 
+        @NotNull Random random, @NotNull TilePosc blockPos, 
+        @NotNull Direction direction, double offX, double offY, double offZ
+    ) {
+        useOnBlock(selfStack, world, null, blockPos, direction);
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java b/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
index 3a7e3922b..00f3d3262 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
@@ -31,7 +31,7 @@ public class ItemSnowball extends Item implements IDispensable {
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         ProjectileSnowball snowball = new ProjectileSnowball(world, blockPos.x() + offX, blockPos.y() + offY, blockPos.z() + offZ);
-        snowball.setHeading(direction.getOffsetX() * 0.6, direction.getOffsetY() == 0 ? 0.1 : direction.getOffsetY() * 0.6, direction.getOffsetZ() * 0.6f, 1.1F, 6F);
+        snowball.setHeading(direction.offsetX() * 0.6, direction.offsetY() == 0 ? 0.1 : direction.offsetY() * 0.6, direction.offsetZ() * 0.6f, 1.1F, 6F);
         world.entityJoinedWorld(snowball);
         selfStack.stackSize -= 1;
     }
@@ -40,7 +40,7 @@ public class ItemSnowball extends Item implements IDispensable {
     public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
         if (selfStack.consumeItem(null)) {
             ProjectileSnowball snowball = new ProjectileSnowball(world, x, y, z);
-            snowball.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+            snowball.setHeading(direction.offsetX(), direction.offsetY() + 0.1D, direction.offsetZ(), 1.1F, 6F);
             world.entityJoinedWorld(snowball);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
index 59e3381a7..09e183355 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStatue.java
@@ -30,15 +30,17 @@ public class ItemStatue extends Item {
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection(), new TilePos());
+            blockPos = blockPos.add(side.direction(), new TilePos());
         }
         if (!this.statueBlockBottom.canPlaceAt(world, blockPos)) {
             return false;
         }
 
+        selfStack.consumeItem(player);
         world.setBlockTypeData(blockPos, this.statueBlockBottom, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
         world.setBlockTypeData(blockPos.up(new TilePos()), this.statueBlockTop, MathHelper.floor((double) (((player.yRot + 180F) * 16F) / 360F) + 0.5D) & 0xf);
-        selfStack.consumeItem(player);
+        world.markBlockNeedsUpdate(blockPos);
+        world.markBlockNeedsUpdate(blockPos.up(new TilePos()));
         
         this.statueBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
         this.statueBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
@@ -49,8 +51,7 @@ public class ItemStatue extends Item {
                 tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
             }
         }
-        world.notifyBlockChange(blockPos, this.statueBlockBottom);
-        world.notifyBlockChange(blockPos.up(new TilePos()), this.statueBlockTop);
+        world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, blockPos, this.statueBlockBottom);
         
         world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
 
@@ -66,15 +67,15 @@ public class ItemStatue extends Item {
             return;
         }
 
-        world.noNeighborUpdate = true;
-        world.setBlockTypeNotify(blockPos, this.statueBlockBottom);
-        world.setBlockTypeNotify(blockPos.up(new TilePos()), this.statueBlockTop);
-        world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockPos, this.statueBlockBottom);
-        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.statueBlockTop);
+        world.setBlockType(blockPos, this.statueBlockBottom);
+        world.setBlockType(blockPos.up(new TilePos()), this.statueBlockTop);
+        world.markBlockNeedsUpdate(blockPos);
+        world.markBlockNeedsUpdate(blockPos.up(new TilePos()));
+        world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, blockPos, this.statueBlockBottom);
+
         world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.statueBlockBottom, EnumBlockSoundEffectType.PLACE);
-        this.statueBlockBottom.onPlacedOnSide(world, blockPos, direction.getSide(), 0.5, 0.5);
-        this.statueBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.getSide(), 0.5, 0.5);
+        this.statueBlockBottom.onPlacedOnSide(world, blockPos, direction.side(), 0.5, 0.5);
+        this.statueBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.side(), 0.5, 0.5);
 
         if (this.statueBlockBottom.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
             TileEntity tileEntity = world.getTileEntity(blockPos);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index 8979d9b70..15b0765d7 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -68,11 +68,11 @@ public class ItemWandSpawner extends Item implements IDispensable
 
     @Override
     public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
-        spawnEntity(selfStack, world, x + direction.getOffsetX() * 0.5, y + direction.getOffsetY() * 0.5, z + direction.getOffsetZ() * 0.5);
+        spawnEntity(selfStack, world, x + direction.offsetX() * 0.5, y + direction.offsetY() * 0.5, z + direction.offsetZ() * 0.5);
     }
 
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        spawnEntity(selfStack, world, blockPos.x() + offX + direction.getOffsetX() * 0.5, blockPos.y() + offY + direction.getOffsetY() * 0.5, blockPos.z() + offZ + direction.getOffsetZ() * 0.5);
+        spawnEntity(selfStack, world, blockPos.x() + offX + direction.offsetX() * 0.5, blockPos.y() + offY + direction.offsetY() * 0.5, blockPos.z() + offZ + direction.offsetZ() * 0.5);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index 895ae1556..3141a025f 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -211,6 +211,7 @@ public final class Items {
     public static Item WAND_NBT;
 //    public static Item RUBYGLASS_DUST;
     public static Item RUBYGLASS_CRYSTAL;
+    public static Item TIMER;
 
     public static Item ARMOR_WOLF_LEATHER;
     public static Item ARMOR_WOLF_CHAINMAIL;
@@ -344,7 +345,7 @@ public final class Items {
         SUGARCANE = (new ItemPlaceable("sugarcane", "minecraft:item/sugarcane", 16466, Blocks.SUGARCANE));
         PAPER = (new Item("paper", "minecraft:item/paper", 16467));
         BOOK = (new Item("book", "minecraft:item/book", 16468));
-        SLIMEBALL = (new Item("slimeball", "minecraft:item/slimeball", 16469));
+        SLIMEBALL = (new ItemSlimeball("slimeball", "minecraft:item/slimeball", 16469));
         MINECART_CHEST = (new ItemMinecart("minecart.chest", "minecraft:item/minecart_chest", 16470, EntityMinecart.CHEST_CART));
         MINECART_FURNACE = (new ItemMinecart("minecart.furnace", "minecraft:item/minecart_furnace", 16471, EntityMinecart.FURNACE_CART));
         EGG_CHICKEN = (new ItemEgg("egg.chicken", "minecraft:item/egg_chicken", 16472));
@@ -413,7 +414,7 @@ public final class Items {
         LANTERN_FIREFLY_BLUE = (new ItemPlaceable("lantern.firefly.blue", "minecraft:item/lantern_firefly_blue", 16521, Blocks.LANTERN_FIREFLY_BLUE));
         LANTERN_FIREFLY_ORANGE = (new ItemPlaceable("lantern.firefly.orange", "minecraft:item/lantern_firefly_orange", 16522, Blocks.LANTERN_FIREFLY_ORANGE));
         LANTERN_FIREFLY_RED = (new ItemPlaceable("lantern.firefly.red", "minecraft:item/lantern_firefly_red", 16523, Blocks.LANTERN_FIREFLY_RED));
-        //    candleSoulwax = new ItemPlaceable("candle.soulwax", 16524, Block.candleSoulwax).setIconCoord(5, 10);
+        TIMER = (new ItemPlaceable("timer", "minecraft:item/timer", 16524, Blocks.TIMER));
         BASKET = new ItemPlaceable("basket", "minecraft:item/basket", 16525, Blocks.BASKET);
         FLAG = new ItemFlag("flag", "minecraft:item/flag", 16526);
         ARMOR_BOOTS_ICESKATES = new ItemIceSkates("armor.boots.iceskates", "minecraft:item/armor_boots_iceskates", 16527);
@@ -446,6 +447,7 @@ public final class Items {
 //        RUBYGLASS_DUST = (new Item("rubyglass.crystal.cracked", "minecraft:item/rubyglass_crystal_cracked", 16554));
         RUBYGLASS_CRYSTAL = (new Item("rubyglass.crystal.pure", "minecraft:item/rubyglass_crystal_pure", 16555));
 
+
         ARMOR_WOLF_LEATHER = new ItemArmor<>("armor.wolf.leather", "minecraft:item/armor_wolf_leather", 16556, ArmorMaterial.LEATHER, WolfArmorShape.BODY);
         ARMOR_WOLF_CHAINMAIL = new ItemArmor<>("armor.wolf.chainmail", "minecraft:item/armor_wolf_chainmail", 16557, ArmorMaterial.CHAINMAIL, WolfArmorShape.BODY);
         ARMOR_WOLF_IRON = new ItemArmor<>("armor.wolf.iron", "minecraft:item/armor_wolf_iron", 16558, ArmorMaterial.IRON, WolfArmorShape.BODY);
